import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;

import ch.ethz.ssh2.InteractiveCallback;

class PasswordDialog extends JDialog implements ActionListener
{
	JLabel passLabel;
	JPasswordField passField;
	
	public void actionPerformed(ActionEvent e) {
		if( e.getSource() == passField ) {
			dispose();
		}
	}
	
	public String getPassword()
	{
		return new String( passField.getPassword() );
	}
	
	public PasswordDialog( Frame owner, String title, String prompt, boolean modal )
	{
		super( owner, title, modal );
		
		passLabel = new JLabel( prompt );
		passField = new JPasswordField( 10 );
		passField.addActionListener( this );
		
		getContentPane().setLayout( new FlowLayout() );
		getContentPane().add( passLabel );
		getContentPane().add( passField );
		pack();
		setLocationRelativeTo( null );
		setVisible( true );
	}
}

public class Auth implements InteractiveCallback {
	
	public static String getUsername()
	{
		return JOptionPane.showInputDialog( null, "使用者名稱：", "使用者名稱", JOptionPane.QUESTION_MESSAGE);
	}

	public static String getPasword( String title, String prompt )
	{
		PasswordDialog d = new PasswordDialog( null, title, prompt, true );
		return d.getPassword();
	}
	
	public String[] replyToChallenge(String name, String instruction, int numPrompts, String[] prompt, boolean[] echo) throws Exception {
		
		String[] ret = new String[numPrompts];
		
		// System.out.println("name: " + name );
		// System.out.println("instruction: " + instruction );
		
		for( int i = 0; i < numPrompts; i++) {
			if( echo[i] ) {
				ret[i] = JOptionPane.showInputDialog( null, prompt[i], "Challenge", JOptionPane.QUESTION_MESSAGE);
			} else {
				ret[i] = getPasword( "Challenge", prompt[i] );
			}
		}
		
		return ret;
	}
	
}
