import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

public class Site {

	// 識別名稱
	public String name;

	// hostname and port
	public String host;
	public int port;
	
	// 通訊協定 (telnet or ssh)
	public int protocol;
	
	// 別名
	public String alias;
	
	// 自動連線、連線後自動登入
	public boolean autoconnect, autologin;
	
	// 登入前以及登入後該自動輸入的字串。
	public String prelogin, postlogin;
	
	// 使用者帳號、密碼及其提示字串。
	public String usernameprompt, username, userpassprompt, userpass;
	
	// 上次連線時間。
	public Date lastvisit;
	
	// 編號
	int order;
	
	public String toString()
	{
		Vector v = new Vector();
		
		v.addElement( "name=" + name );
		v.addElement( "host=" + host );
		v.addElement( "port=" + new Integer(port).toString() );
		v.addElement( "protocol=" + Network.proto[protocol] );
		v.addElement( "alias=" + alias );
		
		if( autoconnect ) {
			v.addElement( "autoconnect=true" );
		} else {
			v.addElement( "autoconnect=false" );	
		}
		
		return CSV.generate( v );
	}
	
	public Site( String n, String h, int p )
	{
		name = n;
		host = h;
		port = p;
		
		protocol = Network.TELNET;
		alias = "";
		autoconnect = false;
		autologin = false;
	}
	
	public Site( String h )
	{
		Vector v = CSV.parse( h );
		Iterator iter = v.iterator();
		String s, key, value;
		int i;
		
		protocol = Network.TELNET;
		alias = "";
		autoconnect = false;
		autologin = false;
		
		while( iter.hasNext() ) {
			s = (String)iter.next();
			i = s.indexOf("=");
			
			key = s.substring( 0, i );
			value = s.substring( i + 1 );
			
			if( key.equalsIgnoreCase("name") ) {
				name = value;
			} else if( key.equalsIgnoreCase("host") ) {
				host = value;
			} else if( key.equalsIgnoreCase("port") ) {
				port = Integer.parseInt( value );
			} else if( key.equalsIgnoreCase("protocol") ) {
				for( int j = 0; j < Network.proto.length; j++ ) {
					if( value.equalsIgnoreCase( Network.proto[j] ) ) {
						protocol = j;
						break;
					}
				}
			} else if( key.equalsIgnoreCase("alias") ) {
				alias = value;
			} else if( key.equalsIgnoreCase("autoconnect") ) {
				autoconnect = value.equalsIgnoreCase("true"); 
			}
		}
	}
	
}
